// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#pragma once

// CConsoleView r[

class CConsoleView : public CEditView
{
	DECLARE_DYNCREATE(CConsoleView)

protected:
	CConsoleView();           // IŎgp protected RXgN^
	virtual ~CConsoleView();

public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

private:
	enum { CONSOLE_VIEW_BUFSIZE = 4096 };
	DWORD m_ExitCode;
	CHAR m_OutBuf[CONSOLE_VIEW_BUFSIZE];		// R\[o͗p
	CHAR m_OutBuf2[CONSOLE_VIEW_BUFSIZE * 2];	// sR[hpobt@
#ifdef _UNICODE
	WCHAR m_FormatBufW[CONSOLE_VIEW_BUFSIZE * 2];	// `p(UNICODE)
#endif
	CHAR m_LastChar;							// Ōɏo͂
	VOID Display(VOID);							// ʂɕ\
public:
	virtual void OnInitialUpdate();
	BOOL Execute(LPCTSTR cmd, LPCTSTR currentDir = NULL);
	afx_msg void OnEnChange();
	VOID Clear(VOID)
	{
		m_LastChar = NULL;
		SetWindowText(_T(""));
	}
};


