// LineWindow.cpp : t@C
//

// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "stdafx.h"
#include "TeXnician.h"
#include "LineWindow.h"
#include ".\linewindow.h"
#include "Values.h"

// CLineWindow

IMPLEMENT_DYNAMIC(CLineWindow, CWnd)
CLineWindow::CLineWindow() : m_BkColor((COLORREF)theApp.GetProfileInt(_T("LineWindowColor"), _T("Background"), (int)LINE_WINDOW_DEFAULT_BKCOLOR))
{
}

CLineWindow::~CLineWindow()
{
	theApp.WriteProfileInt(_T("LineWindowColor"), _T("Background"), (int)m_BkColor);
}


BEGIN_MESSAGE_MAP(CLineWindow, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CLineWindow bZ[W nh


void CLineWindow::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO : ɃbZ[W nh R[hǉ܂B
	// `惁bZ[W CWnd::OnPaint() ĂяoȂłB
	CRichEditView *pParent = (CRichEditView *)GetParent();		// eƂȂ郊b`GfBbg擾
	CRichEditCtrl &ParentCtrl = pParent->GetRichEditCtrl();	// ̃Rg[擾

	// wihԂ
	CRect rect;
	GetClientRect(&rect);
	dc.FillSolidRect(&rect, m_BkColor);

	// tHg̑I
	CHARFORMAT2 cf;
	ParentCtrl.GetDefaultCharFormat(cf);
	LOGFONT lf;
	CFont newFont;
	memset(&lf, 0, sizeof(lf));
	_tcscpy(lf.lfFaceName, cf.szFaceName);
	lf.lfHeight = static_cast<LONG>(static_cast<double>(cf.yHeight) * static_cast<double>(dc.GetDeviceCaps(LOGPIXELSY)) / 1440.0) ;
	newFont.CreateFontIndirect(&lf);
	CFont *oldFont = dc.SelectObject(&newFont);

	int startLine = ParentCtrl.GetFirstVisibleLine();		// \Ă擪̍sԍ
	int lineCount = ParentCtrl.GetLineCount();	// s
	for (int i = startLine; i < lineCount; i++) {
		int firstCharIndex = ParentCtrl.LineIndex(i);
		CPoint firstCharPos = ParentCtrl.PosFromChar(ParentCtrl.LineIndex(i));
		ParentCtrl.ClientToScreen(&firstCharPos);	// eEBhẼNCAgWXN[Wɕϊ
		ScreenToClient(&firstCharPos);		// ̃NCAgWɕϊ
		firstCharPos.y += static_cast<LONG>((static_cast<double>(LINE_COUNT_CORRECTION) / static_cast<double>(LINE_COUNT_CORRECTION_SIZE)) * static_cast<double>(cf.yHeight));	// W̕␳
		if (firstCharPos.y > rect.bottom) {
			break;
		}
		CString str;
		str.Format(_T("%5d"), i + 1);
		dc.TextOut(0, firstCharPos.y, str);
	}

	// tHǧn
	dc.SelectObject(oldFont);
	newFont.DeleteObject();
}
