// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#pragma once

class CStringEx : public CString
{
public:
	CStringEx(void) {
	}

	CStringEx(const CStringEx &str) : CString(str) {
	}
	
	CStringEx(const CString &str) : CString(str) {
	}

	CStringEx(TCHAR ch, int nRepeat = 1) : CString(ch, nRepeat) {
	}

	CStringEx(LPCSTR lpsz) : CString(lpsz) {
	}

	CStringEx(LPCWSTR lpsz) : CString(lpsz) {
	}

	CStringEx(LPCTSTR lpch, int nLength) : CString(lpch, nLength) {
	}

	CStringEx(const unsigned char *psz) : CString(psz) {
	}

	~CStringEx(void) {
	}

	int FindString(LPCTSTR str, int iStart = 0) const;	// 
	int GetNextIndex(int index) const;	// ̃̕CfbNX擾
	int GetBeforeIndex(int index) const;	// Õ̕CfbNX擾
	int GetFirstIndexExcluding(LPCTSTR charSet, int iStart = 0) const;	// charSet Ɋ܂܂ȂŏɓoꂷCfbNX擾
};
