// TeXnician.cpp : AvP[ṼNX`܂B
//

// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "stdafx.h"
#include "TeXnician.h"
#include "MainFrm.h"
#include "TeXnicianDoc.h"
#include "UltraEditView.h"
#include <new>
#include ".\texnician.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define APP_PATH_SIZE	4096

using namespace std;

// CTeXnicianApp

BEGIN_MESSAGE_MAP(CTeXnicianApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// ẄZbgAbv R}h
//	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()


// CTeXnicianApp RXgNV

CTeXnicianApp::CTeXnicianApp()
{
	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
	// nkf32.dlľĂяo
//	m_hnkf = AfxLoadLibrary(_T("nkf32.dll"));
	m_hnkf = ::LoadLibrary(_T("nkf32.dll"));		// MFCX^eBbNNƁAAfxLoadLibrary͎gȂ	
	// AvP[VEpX̎擾
	m_AppPath = NULL;
	try {
		m_AppPath = new TCHAR[APP_PATH_SIZE];
		memset(m_AppPath, NULL, sizeof(TCHAR) * APP_PATH_SIZE);
		if (!::GetModuleFileName(m_hInstance, m_AppPath, APP_PATH_SIZE)) {
			delete [] m_AppPath;
			m_AppPath = NULL;
		}
		// pX̋؂/\ɂ(Ô)
		LPTSTR p = _tcschr(m_AppPath, _T('/'));
		while(p) {
			*p = _T('\\');
			p = _tcschr(m_AppPath, _T('/'));
		}
		// Ō\؂̂Ă
		p = _tcsrchr(m_AppPath, _T('\\'));
		if (!p) {
			memset(m_AppPath, NULL, sizeof(TCHAR) * APP_PATH_SIZE);
			_tcscpy(m_AppPath, _T("."));
		} else {	// |
			*p = NULL;
			while (*(++p)) {
				*p = NULL;
			}
		}
	} catch (bad_alloc xa) {
		m_AppPath = NULL;
	}
}

CTeXnicianApp::~CTeXnicianApp()
{
	// OR}h̐ݒۑ
	m_ExternCmd.Update();
	if (m_AppPath) {
		delete [] m_AppPath;
	}
	m_AppPath = NULL;
	if (m_hnkf) {
//		AfxFreeLibrary(m_hnkf);
		::FreeLibrary(m_hnkf);
	}
	m_hnkf = NULL;
}

// B CTeXnicianApp IuWFNgłB

CTeXnicianApp theApp;

// CTeXnicianApp 

BOOL CTeXnicianApp::InitInstance()
{
	// AvP[V@}jtFXg@visual X^CLɂ邽߂ɁA
	// ComCtl32.dll o[W 6@ȍ~̎gpw肷ꍇ́A
	// Windows XP Ɂ@InitCommonControls() KvłBȂ΁AEBhE쐬ׂ͂Ďs܂B
	InitCommonControls();

	CWinApp::InitInstance();

	// W
	// ̋@\g킸ɁAŏIIȎs\t@C̃TCYkꍇ́A
	// ȉAsvȏ[`
	// 폜ĂB
	// ݒ肪i[Ă郌WXg L[ύX܂B
	// TODO: ̕AЖ܂͑gDȂǂ́A
	// K؂ȕɕύXĂB
	// ݒ̓WXgł͂ȂAAvP[V̎st@CfBNgINIt@CAɊi[
//	SetRegistryKey(_T("AvP[V EBU[hŐꂽ[J AvP[V"));
	free((void *)m_pszProfileName);
	CString iniFileName;
	iniFileName.Format(_T("%s\\%s.ini"), GetAppPath(), m_pszExeName);
	TRACE(_T("INI File Name = %s\n"), static_cast<LPCTSTR>(iniFileName));
	m_pszProfileName = _tcsdup(iniFileName);
	LoadStdProfileSettings(4);  // W INI t@C̃IvV[h܂ (MRU ܂)
	// OvOo^
	m_ExternCmd.RemoveAll();
	m_ExternCmd.Add(CCommandType(_T("platex"), _T("platex.exe"), _T("\"%s.tex\"")));
	m_ExternCmd.Add(CCommandType(_T("jbibtex"), _T("jbibtex.exe"), _T("\"%s\"")));
	m_ExternCmd.Add(CCommandType(_T("dviout"), _T("C:\\dviout\\dviout.exe"), _T("\"%s.dvi\"")));
	m_ExternCmd.Add(CCommandType(_T("dvipsk"), _T("dvipsk.exe"), _T("-Ppdf \"%s.dvi\"")));
	m_ExternCmd.Add(CCommandType(_T("dvipdfmx"), _T("dvipdfmx.exe"), _T("\"%s.dvi\"")));
	m_ExternCmd.Add(CCommandType(_T("GSView"), _T("gsview32.exe"), _T("\"%s.ps\"")));
	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CTeXnicianDoc),
		RUNTIME_CLASS(CMainFrame),       // C SDI t[ EBhE
		RUNTIME_CLASS(CUltraEditView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);
	// DDE Execute open gp\ɂ܂B
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);
	// DDEAfile open ȂǕW̃VF R}h̃R}hC͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	// R}h CŎw肳ꂽfBXpb` R}hłBAvP[V
	// /RegServerA/RegisterA/Unregserver ܂ /Unregister ŋNꂽꍇA False Ԃ܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	// C EBhEꂽ̂ŁA\ƍXVs܂B
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	// ڔ݂ꍇɂ̂ DragAcceptFiles ĂяoĂB
	//  SDI AvP[Vł́AProcessShellCommand ̒ɂ̌ĂяoȂ΂Ȃ܂B
	// hbO/hbv I[v܂B
	m_pMainWnd->DragAcceptFiles();
	return TRUE;
}



// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CTeXnicianApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CTeXnicianApp bZ[W nh

