// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#pragma once

#include <afxtempl.h>
#include "CommandType.h"

class CCommandArray :
	public CArray<CCommandType>
{
public:
	CCommandArray(void);
	virtual ~CCommandArray(void);
	CCommandType Get(LPCTSTR name);
	VOID Update(VOID);
	INT_PTR Find(LPCTSTR str) const;
	INT_PTR Find(const CString &str) const
	{
		return Find((LPCTSTR)str);
	}
};
