// ExternProgSettingDlg.cpp : t@C
//

// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "stdafx.h"
#include "TeXnician.h"
#include "ExternProgSettingDlg.h"
#include ".\externprogsettingdlg.h"


// CExternProgSettingDlg _CAO

IMPLEMENT_DYNAMIC(CExternProgSettingDlg, CDialog)
CExternProgSettingDlg::CExternProgSettingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExternProgSettingDlg::IDD, pParent)
	, m_CommandEdit(_T(""))
	, m_CommandLineEdit(_T(""))
{
}

CExternProgSettingDlg::~CExternProgSettingDlg()
{
}

void CExternProgSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EXTPROG_SETTING_LIST, m_List);
	DDX_Text(pDX, IDC_EXTPROG_SETTING_COMMAND, m_CommandEdit);
	DDX_Text(pDX, IDC_EXTPROG_SETTING_COMMANDLINE, m_CommandLineEdit);
}


BEGIN_MESSAGE_MAP(CExternProgSettingDlg, CDialog)
	ON_LBN_SELCHANGE(IDC_EXTPROG_SETTING_LIST, OnLbnSelchangeExtprogSettingList)
	ON_BN_CLICKED(IDC_EXTPROG_SETTING_REFBUTTON, OnBnClickedExtprogSettingRefbutton)
END_MESSAGE_MAP()


// CExternProgSettingDlg bZ[W nh

BOOL CExternProgSettingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO :  ɏǉĂ
	m_List.ResetContent();
	m_Array.Copy(theApp.m_ExternCmd);
	INT_PTR count = m_Array.GetCount();
	for (INT_PTR i = 0; i < count; i++) {
		m_List.AddString(m_Array.GetAt(i).GetAppName());
	}

	m_LastSelection = -1;
	m_List.SetCurSel(0);
	CString str;
	m_List.GetText(0, str);
	CCommandType cmd = m_Array.Get(str);
	m_CommandEdit = cmd.GetExeName();
	m_CommandLineEdit = cmd.GetOption();
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CExternProgSettingDlg::OnLbnSelchangeExtprogSettingList()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_LastSelection != -1) {
		UpdateData(TRUE);
		m_CommandEdit.TrimLeft();
		m_CommandEdit.TrimRight();
		m_CommandLineEdit.TrimLeft();
		m_CommandLineEdit.TrimRight();
		CString str;
		m_List.GetText(m_LastSelection, str);
		INT_PTR index = m_Array.Find(str);
		CCommandType cmd = m_Array.GetAt(index);
		cmd.SetExeName(m_CommandEdit);
		cmd.SetOption(m_CommandLineEdit);
		m_Array.SetAt(index, cmd);
	}
	int sel = m_List.GetCurSel();
	if (sel != LB_ERR) {
		m_LastSelection = sel;
		CString str;
		m_List.GetText(sel, str);
		CCommandType cmd = m_Array.Get(str);
		m_CommandEdit = cmd.GetExeName();
		m_CommandLineEdit = cmd.GetOption();
		UpdateData(FALSE);
	}
}

void CExternProgSettingDlg::OnOK()
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	int sel = m_List.GetCurSel();
	if (sel != LB_ERR) {
		UpdateData(TRUE);
		m_CommandEdit.TrimLeft();
		m_CommandEdit.TrimRight();
		m_CommandLineEdit.TrimLeft();
		m_CommandLineEdit.TrimRight();
		CString str;
		m_List.GetText(sel, str);
		INT_PTR index = m_Array.Find(str);
		CCommandType cmd = m_Array.GetAt(index);
		cmd.SetExeName(m_CommandEdit);
		cmd.SetOption(m_CommandLineEdit);
		m_Array.SetAt(index, cmd);
	}
	// ݒ𔽉f
	theApp.m_ExternCmd.Copy(m_Array);

	CDialog::OnOK();
}

void CExternProgSettingDlg::OnBnClickedExtprogSettingRefbutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CString filter;
	filter.LoadString(IDS_STRING_EXEFILE_FILTER);
	CFileDialog dlg(TRUE, _T("exe"), NULL, OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST, filter, this);
	if (dlg.DoModal() == IDOK) {
		m_CommandEdit = dlg.GetPathName();
		UpdateData(FALSE);
	}
}
