// TeXnicianDoc.h : CTeXnicianDoc NX̃C^[tFCX
//

// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.


#pragma once

class CTeXnicianDoc : public CRichEditDoc
{
protected: // VÂݍ쐬܂B
	CTeXnicianDoc();
	DECLARE_DYNCREATE(CTeXnicianDoc)

// 
public:

// 
public:

// I[o[Ch
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual CRichEditCntrItem* CreateClientItem(REOBJECT* preo) const;

// 
public:
	virtual ~CTeXnicianDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

private:
	USHORT m_FileLoadEncoding;		// ǂݍ܂ꂽt@C̕GR[fBO
	USHORT m_FileSaveEncoding;		// ۑۂɎgp镶GR[fBO
	typedef struct {
		LPSTR image;		// t@CC[W
		UINT size;			// t@CTCY
	} FileImageType;
	FileImageType m_RawImage;
	typedef struct {
		CString texFile;				// RpCTeXt@C(pX͏)
		CString texFileNoExt;			// gqt@C(pX)
		CString texFilePath;			// pX
	}TEXFILE_DATA;
	TEXFILE_DATA m_TeXFileData;

	USHORT GetLFCode(LPCSTR buf, UINT bufsize);		// sR[h擾
	VOID ChangeViewEncoding(USHORT kanjiCode);		// \R[hύX
	VOID ClearTeXFileData(VOID)
	{
		m_TeXFileData.texFile.Empty();
		m_TeXFileData.texFileNoExt.Empty();
		m_TeXFileData.texFilePath.Empty();
	}
	// t@CgqƁApXƂɕ
	VOID SetTeXFileData(CFile *file);

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnUpdateFileSavingEncoding(CCmdUI *pCmdUI);
	afx_msg void OnUpdateViewEncodingEucjp(CCmdUI *pCmdUI);
	afx_msg void OnUpdateViewEncodingIso2022jp(CCmdUI *pCmdUI);
	afx_msg void OnUpdateViewEncodingShiftjis(CCmdUI *pCmdUI);
	afx_msg void OnUpdateViewEncodingUtf16be(CCmdUI *pCmdUI);
	afx_msg void OnUpdateViewEncodingUtf16le(CCmdUI *pCmdUI);
	afx_msg void OnUpdateViewEncodingUtf8(CCmdUI *pCmdUI);
	afx_msg void OnViewEncodingEucjp();
	afx_msg void OnViewEncodingIso2022jp();
	afx_msg void OnViewEncodingShiftjis();
	afx_msg void OnViewEncodingUtf16be();
	afx_msg void OnViewEncodingUtf16le();
	afx_msg void OnViewEncodingUtf8();
	afx_msg void OnFileSavingEncoding();
	afx_msg void OnFileSave();
	afx_msg void OnExecutePlatex();
	afx_msg void OnExecuteJbibtex();
	afx_msg void OnExecuteDviout();
	afx_msg void OnExecuteDvips();
	afx_msg void OnExecuteDvipdfmx();
	afx_msg void OnExecuteGsview();
};


